unit Sercheng;
{$X+}
interface
uses
  SysUtils;


function CompareStrings(Target, Pattern: PChar;
                CaseSensitive: Boolean; PatternMatch: Boolean): boolean;

function IsPatternWild(pattern: PChar): Boolean;

{**********  Aaron *********************}
procedure SetMultiPat(MultiPat: PChar);
procedure SetSinglePat(SinglePat: Char);
function GetMultiPat: PChar;
function GetSinglePat: Char;
{**********  Aaron *********************}

implementation

{**********  Aaron *********************}
const
   MAXMULTIPAT = 5;
var
   pMultiPat: array[0..MAXMULTIPAT]of Char;
   pSinglePat: Char;
{**********  Aaron *********************}


function IsPatternWild(pattern: PChar): Boolean;
begin
  Result := StrPos(pattern, pMultiPat) <> nil;
  if not Result then Result := StrScan(pattern, pSinglePat) <> nil;
end;

function CompareStrings(Target, Pattern: PChar;
                CaseSensitive: Boolean; PatternMatch: Boolean): Boolean;

{Removes non printing characters at the end of a string}
function StripNPAtTail(StrPtr: PChar): PChar;
var
  P: PChar;
begin
  P := StrPtr + StrLen(StrPtr);
  while Ord(P^) < 32 do
  begin
    P^ := #0;
    P := P - 1;
  end;
  Result := StrPtr;
end;

function MatchPattern(Target, Pattern: PChar): Boolean;
var
  NextWC, P: PChar;
  SearchStr: Array[0..255] of char;
begin
  if 0 = StrComp(Pattern, pMultiPat) then
    Result := True
  else if (Target^ = Chr(0)) and (Pattern^ <> Chr(0)) then
    Result := False
  else if Target^ = Chr(0) then
    Result := True
  else if 0 = StrLComp(Pattern, pMultiPat, 2) then
  begin
    if not IsPatternWild(Pattern + 2) then
    begin
      P := StrPos(Target, Pattern + 2);
      {If pattern is at the end of the target}
      if (P <> nil)
      and (((StrLen(P) = StrLen(Pattern + 2)) or
      (StrLen(StripNPAtTail(P)) = StrLen(Pattern + 2))))
      then
        Result := True
      else
        Result := False;
    end
    else
    begin
      {Detect any wild cards ahead}
      NextWC := StrPos(Pattern + 2, pMultiPat);
  {****************** Aaron *************************}
  {      P := StrPos(Pattern + 2, SinglePat);}
      P := StrScan(Pattern + 2, pSinglePat);
  {****************** Aaron *************************}
      if (NextWC = nil) then
        NextWC := P
      else if (P <> nil) and (P < NextWC) then
        NextWC := P;
      StrLCopy(SearchStr, Pattern + 2, NextWC - Pattern - 2);
      P := StrPos(Target, SearchStr);
      {We didn't find the part after the wild card '..' or we found it at
the very start!}
      if (P = nil) or (P = Target) then
        Result := False
      else
        Result := MatchPattern(P + StrLen(SearchStr), NextWC);
    end;
  end
  else if Pattern^ = pSinglePat then
  begin
    repeat
      Inc(Pattern);
      Inc(Target);
    until (Pattern^ <> pSinglePat);
    Result := MatchPattern(Target, Pattern);
  end
  else if Target^ = Pattern^ then
  begin
    repeat
      Inc(Pattern);
      Inc(Target);
    until (Pattern^ = Chr(0)) or (Target^ = Char(0)) or (Target^ <>         
Pattern^);
    Result := MatchPattern(Target, Pattern)
  end
  else
    Result := False;
end;

begin

  {if not case sensitive then make strings uppercase}
  if(not CaseSensitive)then
  begin
    StrUpper(Target);
    StrUpper(Pattern);
  end;


  if not PatternMatch then
    Result := (StrPos(Target, Pattern) <> nil)
  else
    Result := MatchPattern(Target, Pattern);
end;

{**********  Aaron *********************}
procedure SetMultiPat(MultiPat: PChar);
begin
   StrLCopy(pMultiPat, MultiPat, MAXMULTIPAT);
end;

procedure SetSinglePat(SinglePat: Char);
begin
   pSinglePat := SinglePat;
end;

function GetMultiPat: PChar;
begin
   Result := pMultiPat;
end;

function GetSinglePat: Char;
begin
   Result := pSinglePat;
end;

begin
   StrCopy(pMultiPat, '..');
   pSinglePat := '@';
{**********  Aaron *********************}
end.

(*
// ==============================================================
// Copyright (c) 1996 by Aaron Castro and VK Thakur. All rights reserved
// Version 1.00 (Beta)   Date: 01/01/96
*)

